# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.  # noqa: E501

    The version of the OpenAPI document: 3.0
    Contact: support@akeyless.io
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from akeyless.configuration import Configuration


class DeactivateAcmeAccount(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'acme_account_id': 'str',
        'cert_issuer_name': 'str',
        'delete_account': 'bool',
        'json': 'bool',
        'token': 'str',
        'uid_token': 'str'
    }

    attribute_map = {
        'acme_account_id': 'acme-account-id',
        'cert_issuer_name': 'cert-issuer-name',
        'delete_account': 'delete-account',
        'json': 'json',
        'token': 'token',
        'uid_token': 'uid-token'
    }

    def __init__(self, acme_account_id=None, cert_issuer_name=None, delete_account=None, json=False, token=None, uid_token=None, local_vars_configuration=None):  # noqa: E501
        """DeactivateAcmeAccount - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._acme_account_id = None
        self._cert_issuer_name = None
        self._delete_account = None
        self._json = None
        self._token = None
        self._uid_token = None
        self.discriminator = None

        self.acme_account_id = acme_account_id
        self.cert_issuer_name = cert_issuer_name
        if delete_account is not None:
            self.delete_account = delete_account
        if json is not None:
            self.json = json
        if token is not None:
            self.token = token
        if uid_token is not None:
            self.uid_token = uid_token

    @property
    def acme_account_id(self):
        """Gets the acme_account_id of this DeactivateAcmeAccount.  # noqa: E501

        The acme account id to deactivate  # noqa: E501

        :return: The acme_account_id of this DeactivateAcmeAccount.  # noqa: E501
        :rtype: str
        """
        return self._acme_account_id

    @acme_account_id.setter
    def acme_account_id(self, acme_account_id):
        """Sets the acme_account_id of this DeactivateAcmeAccount.

        The acme account id to deactivate  # noqa: E501

        :param acme_account_id: The acme_account_id of this DeactivateAcmeAccount.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and acme_account_id is None:  # noqa: E501
            raise ValueError("Invalid value for `acme_account_id`, must not be `None`")  # noqa: E501

        self._acme_account_id = acme_account_id

    @property
    def cert_issuer_name(self):
        """Gets the cert_issuer_name of this DeactivateAcmeAccount.  # noqa: E501

        The name of the PKI certificate issuer  # noqa: E501

        :return: The cert_issuer_name of this DeactivateAcmeAccount.  # noqa: E501
        :rtype: str
        """
        return self._cert_issuer_name

    @cert_issuer_name.setter
    def cert_issuer_name(self, cert_issuer_name):
        """Sets the cert_issuer_name of this DeactivateAcmeAccount.

        The name of the PKI certificate issuer  # noqa: E501

        :param cert_issuer_name: The cert_issuer_name of this DeactivateAcmeAccount.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and cert_issuer_name is None:  # noqa: E501
            raise ValueError("Invalid value for `cert_issuer_name`, must not be `None`")  # noqa: E501

        self._cert_issuer_name = cert_issuer_name

    @property
    def delete_account(self):
        """Gets the delete_account of this DeactivateAcmeAccount.  # noqa: E501

        Delete the account  # noqa: E501

        :return: The delete_account of this DeactivateAcmeAccount.  # noqa: E501
        :rtype: bool
        """
        return self._delete_account

    @delete_account.setter
    def delete_account(self, delete_account):
        """Sets the delete_account of this DeactivateAcmeAccount.

        Delete the account  # noqa: E501

        :param delete_account: The delete_account of this DeactivateAcmeAccount.  # noqa: E501
        :type: bool
        """

        self._delete_account = delete_account

    @property
    def json(self):
        """Gets the json of this DeactivateAcmeAccount.  # noqa: E501

        Set output format to JSON  # noqa: E501

        :return: The json of this DeactivateAcmeAccount.  # noqa: E501
        :rtype: bool
        """
        return self._json

    @json.setter
    def json(self, json):
        """Sets the json of this DeactivateAcmeAccount.

        Set output format to JSON  # noqa: E501

        :param json: The json of this DeactivateAcmeAccount.  # noqa: E501
        :type: bool
        """

        self._json = json

    @property
    def token(self):
        """Gets the token of this DeactivateAcmeAccount.  # noqa: E501

        Authentication token (see `/auth` and `/configure`)  # noqa: E501

        :return: The token of this DeactivateAcmeAccount.  # noqa: E501
        :rtype: str
        """
        return self._token

    @token.setter
    def token(self, token):
        """Sets the token of this DeactivateAcmeAccount.

        Authentication token (see `/auth` and `/configure`)  # noqa: E501

        :param token: The token of this DeactivateAcmeAccount.  # noqa: E501
        :type: str
        """

        self._token = token

    @property
    def uid_token(self):
        """Gets the uid_token of this DeactivateAcmeAccount.  # noqa: E501

        The universal identity token, Required only for universal_identity authentication  # noqa: E501

        :return: The uid_token of this DeactivateAcmeAccount.  # noqa: E501
        :rtype: str
        """
        return self._uid_token

    @uid_token.setter
    def uid_token(self, uid_token):
        """Sets the uid_token of this DeactivateAcmeAccount.

        The universal identity token, Required only for universal_identity authentication  # noqa: E501

        :param uid_token: The uid_token of this DeactivateAcmeAccount.  # noqa: E501
        :type: str
        """

        self._uid_token = uid_token

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DeactivateAcmeAccount):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, DeactivateAcmeAccount):
            return True

        return self.to_dict() != other.to_dict()
